// pages/index/tab/tab.js
Component({
    /**
     * 组件的属性列表
     */
    properties: {
        StudentapartmentNew: Boolean,
        page: String,
        listTab: Object,
    },

    /**
     * 组件的初始数据
     */
    data: {
        tabList: [{
            name: "个人房源",
            value: "personList",
            url: "/pages/personList/personList"
        }, {
            name: "中介房源",
            value: "quarantineLists",
            url: "/pages/agentList/agentList"
        }, {
            name: "品牌公寓",
            value: "brandApartmentlist",
            url: "/pages/brandApartmentList/brandApartmentList"
        }]
    },

    /**
     * 组件的方法列表
     */
    methods: {
        toPage(e) {
            let page = e.currentTarget.dataset.page;
            let url = e.currentTarget.dataset.url;
            if (!url) url = `/pages/${page}/${page}`

            if (this.properties.page === page) return false
            wx.redirectTo({
                url,
            })
        },

    }
})