// pages/user/user.js
var app = getApp()
var config = {};
var miucms = require('../../utils/miucms.js');
// 发布的状态码不要删除
// status 状态 1正常,0未发布,2关闭,-3被投诉下架,-1用户删除,-2论坛删帖,-4待审,-5到期自动下架

Page({
    /**
     * 页面的初始数据
     */
    data: {
        loding: true,
        showTOTOP: false,
        fav: {
            page: 1,
            data: []
        },
        publish: {
            page: 1,
            data: [],
            loading: false,
        },
        fav_list: [],
        fav_page: {
            next_page: 1
        },
        publish_list: [],
        publish_page: {
            next_page: 1
        },
        user: {},
        tab: 'fav',
        fav_count: 0,
        publish_count: 0,
        loading: false,
        status: 0,
        q: '',
        orderby: {
            title: 'orderby',
            value: "new",
            name: '按最新消息排序',
            show: false,
            list: {
                "new": '按最新消息排序',
                "impression": '按印象排序'
            }
        },
        message_page: {
            next_page: 1
        },
        message_list: [],
        impression: {},
        impression_obj: {
            show: false,
            index: 1,
            impression: 0,
            uniqid: ''
        },
        del_obj: {
            show: false,
            index: 1,
            uniqid: ''
        },
        chage_status_obj: {
            show: false,
            uniqid: '',
            token: '',
            index: 0
        },
        options: {},
        isAuthorization: 0,
        raisePopupState: false,
        screen_data: {
            windowHeight: 0,
            totalTopHeight: 0,
            statusBarHeight: 0,
            titleBarHeight: 0,
        },
        raisePopupMessage: "", // 顶上去升起弹出框的文本
        initState: false,
        triggerRules: 0, // 触发规则状态 0 是未触发 1 是触发规则 1  2 是触发规则2
        topTitle: "",
        langs: {},
        stat: {},

        stateObj: { // btn: 0  删除 编辑 1 删除 编辑 上架  2 删除 编辑 下架 顶上去
            "1": {
                btn: 2,
            },
            "-7": {
                text: "身份变化，已下架",
                btn: -2,
            },
            "-5": {
                text: "超出发布期限，已自动下架",
                btn: 0,
            },
            "-3": {
                text: "多人投诉，已下架",
                btn: -1,
            },
            "-4": {
                text: "该信息正在审核中",
                btn: -1,
            },
            "2": {
                text: "已下架",
                btn: 1,
            },
            "0": {
                text: "草稿",
                btn: 0,
            }
        },

        identityObj: {
            1: {
                text: "中介认证",
                bgcolor: "#9EB1F6",
            },
            0: {
                text: "发布房源",
                bgcolor: "rgba(253, 223, 109, 1)",
            },
            "-1": {
                text: "房源认证",
                bgcolor: "rgba(171, 169, 255, 1)",
            },
        },
        choiceTypeState: false,
        identityList: [],
        newmessagenum: 0,
        validityidentity: "", // 中介有效日期
        failPopState: false, // 提交失败的弹窗状态
        QRCodePopState: false, // 客服弹窗的状态

        authenticatePopupStatus: false, // 认证弹窗状态  intermediary-succeed-pop   
        authenticatePopupState: null, // 认证弹窗状态  intermediary-succeed-pop   

        isShowVideo: true, // 是否显示 视频

    },
    launchAppError(e) {
        console.log(e.detail.errMsg)
    },
    onPageScroll(e) {
        if (e.scrollTop > 1000 && !this.data.showTOTOP) {
            this.setData({
                showTOTOP: true
            })
        } else if (e.scrollTop < 1000 && this.data.showTOTOP) {
            this.setData({
                showTOTOP: false
            })
        }
    },
    /**
     * 生命周期函数--监听页面加载
     */
    timer: null,

    onLoad: function (options) {

        let that = this

        this.setData({
            q: options.q ? options.q : '',
            tab: options.tab ? options.tab : 'fav',
            options: options || {},
            screen_data: app.globalData.screen_data,
            // topTitle: app.globalData.topTitle
        })

        this.getTopTitle()

        this.get_config()
        this.getNoticeNumber()

        app.globalData['langs'] ? this.data.langs = app.globalData['langs'] : this.getDtailsLangs()
    },

    onShow: function () {
        if (JSON.stringify(this.data.user) != "{}") {
            this.setData({
                user: app.globalData.user
            })
        }

        // 消息提示的 红色圈圈 更新
        if (this.isMessageState) {
            if (app.globalData.unreadMessagesState) {
                this.setData({
                    unreadMessages: app.globalData.unreadMessages
                })
            }
            this.getUserInit()
        }

        // 判断是否 上架 需要更新 发布列表数据
        if (app.globalData.editShelfState == "update") {
            const tab = this.data.tab
            this.data.publish['page'] = 1
            this.data.publish['data'] = []
            if (tab == "publish") this.getPublishData()
        }

    },

    getTopTitle() {
        miucms.getTopTitle(this, app)
    },

    // 获取系统通知数量
    getNoticeNumber() {
        if (app.globalData.unreadMessagesState) {
            this.setData({
                unreadMessages: app.globalData.unreadMessages
            })
            return
        }
        miucms.count().then(res => {
            this.setData({
                unreadMessages: res.data.count
            })
        }).catch(() => {})
    },

    // 如果用户已经同意授权。则开始获取数据
    islogin() {
        this.setData({
            initState: true
        })
        this.get_config();
    },

    get_config: function () {
        var that = this;
        if (app.globalData.config.lists) {
            config = app.globalData.config;
            this.setData({
                // user: app.globalData.user,
                status: app.globalData.status,
                wechat: app.globalData.wechat,
                bottomLift: app.globalData.screen_data.bottomLift,
                isShowVideo: app.globalData.isShowVideo,
            })
            this.getUserInit()
        } else {
            setTimeout(function () {
                that.get_config()
            }, 200)
        }
    },

    initData() {
        miucms.request(`${app.globalData.baseURL}/tenement/my`).then(res => {
            if (res.code == 401) {
                this.setData({
                    isAuthorization: 1,
                    loding: false,
                })
                return false
            }
            if (res.code == 200) {
                let data = res.data
                if (this.data.tab == 'fav' && data.count.fav != 0) {
                    this['get_' + this.data.tab]()
                } else if (this.data.tab == 'publish' && data.count.post != 0) {
                    this['get_' + this.data.tab]()
                } else {
                    wx.hideLoading()
                }

                this.setData({
                    landlordcertification: data.landlordcertification,
                    user: data.user,
                    initState: true,
                    loding: false
                })
            } else {
                wx.hideLoading()
                wx.showModal({
                    title: '提示',
                    content: res.message
                })
            }
        }, err => {
            wx.hideLoading()
        })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    first_in: true,
    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {
        let tab = this.data.tab;
        wx.stopPullDownRefresh();
        if (!app.globalData.config.lists) return false

        if (this.data.tab == 'fav') {
            this.setData({
                fav: {
                    page: 1,
                    count: 0,
                    data: []
                }
            })
            this.getFavData()
        } else {
            this.setData({
                publish: {
                    page: 1,
                    count: 0,
                    data: []
                }
            })
            this.getPublishData()
        }
    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {
        if (!app.globalData.config.lists) return false
        if (this.data.tab == 'fav') this.getFavData()
        else this.getPublishData()
    },

    change_tab: function (e) {
        this.setData({
            tab: e.currentTarget.dataset.tab,
        })
        if (this.data[this.data.tab + '_list'].length == 0 && this.data[this.data.tab + '_page'].next_page == 1 && app.globalData.config.lists) {
            // 首次点击tab，加载数据
            this['get_' + this.data.tab]()
        }

    },
    add_to_fav: function (e) {
        let that = this;
        let uniqid = e.currentTarget.dataset.uniqid || e.detail.uniqid;
        let token = e.currentTarget.dataset.token || e.detail.token;
        let index = e.currentTarget.dataset.index || e.detail.index;
        miucms.request(app.globalData.config.collection.operation, {
            token: token,
            uniqid: uniqid
        }).then(data => {
            that.data.fav.data.splice(index, 1);
            if (that.data.fav.data.length == 0) this.getFavData()

            that.data.fav.count = that.data.fav.count - 1
            that.setData({
                fav: this.data.fav
            })

            that.data.fav_list.splice(index, 1);
            that.setData({
                fav_count: data.data.user_count,
                fav_list: that.data.fav_list
            })
            wx.showToast({
                title: data.message,
            })
        }).catch(res => {})

    },
    // 删除帖子
    del_item: function (e) {

        let uniqid = e.currentTarget.dataset.uniqid || e.detail.uniqid;
        let token = e.currentTarget.dataset.token || e.detail.token;
        let index = e.currentTarget.dataset.index || e.detail.index;

        let that = this;
        wx.showModal({
            title: '提示',
            content: '确定删除吗？',
            success: function (res) {
                if (res.confirm === true) {
                    wx.showLoading({
                        title: '正在提交...',
                    })
                    miucms.request(app.globalData.config.post.delete, {
                        token: token,
                        uniqid: uniqid
                    }).then(data => {
                        wx.hideLoading()
                        if (data.extraparam.mode == 'right') {
                            // 成功
                            let status = that.data.publish.data[index].status
                            let stat = that.data.stat

                            if (status == 0) stat['draft']--
                            else if (status == 1) stat['listing']--
                            else stat['offshelf']--

                            that.data.publish.data.splice(index, 1);
                            that.data.publish.count--;
                            that.setData({
                                publish: that.data.publish,
                                stat
                            })


                            wx.showToast({
                                title: data.message,
                            })
                        } else {
                            wx.showModal({
                                title: '提示',
                                content: data.message,
                            })
                        }
                    }).catch(res => {
                        wx.hideLoading()
                    })
                }
            }
        })
    },
    bindcontact: function (re) {},
    show_select: function (e) {
        this.data.orderby.show = true;
        this.setData({
            orderby: this.data.orderby
        })
    },
    select_value: function (e) {
        var that = this;
        let change = true;
        let title = e.currentTarget.dataset.title;
        let value = e.currentTarget.dataset.value;
        let name = e.currentTarget.dataset.name;
        if (that.data[title].value == value) change = false
        else {
            that.data[title].value = value;
            that.data[title].name = name;
        }
        that.data[title].show = false;
        this.setData({
            orderby: this.data.orderby
        })
        // if (change) this.clear_data()

    },

    show_more_item: function (e) {
        let that = this;
        let index = e.currentTarget.dataset.index;
        let show = that.data.message_list[index]['show_more'] ? false : true;
        that.data.message_list[index]['show_more'] = show;
        that.setData({
            message_list: that.data.message_list
        })
    },
    check_item: function (e) {
        var that = this;
        var impression = e.currentTarget.dataset.impression;
        that.data.impression_obj.impression = impression;
        that.setData({
            impression_obj: that.data.impression_obj
        })
        wx.showLoading({
            title: '数据提交中',
        })
        miucms.request(app.globalData.config.message.setimpression, {
            uniqid: that.data.impression_obj.uniqid,
            impression: that.data.impression_obj.impression
        }).then(data => {
            if (data.extraparam.mode == 'right') {
                that.data.impression_obj.show = false;
                that.data.message_list[that.data.impression_obj.index]['impression'] = impression;
                that.setData({
                    impression_obj: that.data.impression_obj,
                    message_list: that.data.message_list
                })
            }
        }).catch(res => {})
    },
    close_alert: function (e) {
        let that = this;
        that.data.impression_obj.show = false;
        that.data.del_obj.show = false;
        that.data.orderby.show = false;
        this.data.chage_status_obj.show = false;
        that.setData({
            impression_obj: that.data.impression_obj,
            del_obj: that.data.del_obj,
            orderby: that.data.orderby,
            chage_status_obj: that.data.chage_status_obj
        })
    },
    del_contacts_item: function (e) {
        let that = this;
        that.data.del_obj.index = e.currentTarget.dataset.i;
        that.data.del_obj.uniqid = e.currentTarget.dataset.uniqid;
        that.data.del_obj.token = e.currentTarget.dataset.token;
        that.data.del_obj.show = true;
        that.setData({
            del_obj: that.data.del_obj
        })
    },
    del_contacts: function (e) {
        let that = this;
        wx.showLoading({
            title: '数据提交中',
        })
        miucms.request(app.globalData.config.message.delete, {
            uniqid: that.data.del_obj.uniqid,
            token: that.data.del_obj.token
        }).then(data => {
            if (data.extraparam.mode == 'right') {
                that.data.del_obj.show = false;
                that.data.impression_obj.show = false;
                that.data.message_list.splice([that.data.del_obj.index], 1);
                that.setData({
                    del_obj: that.data.del_obj,
                    impression_obj: that.data.impression_obj,
                    message_list: that.data.message_list
                })
                wx.showToast({
                    title: data.message,
                })
            } else {
                wx.showModal({
                    title: '提示',
                    content: data.message,
                })
            }

        }).catch(res => {})

    },
    send_form_id: function (e) {
        return false;
    },
    wxParseTagATap: function (e) {
        var url = e.currentTarget.dataset.src;
        wx.navigateTo({
            url: url,
        })
    },
    change_item_status: function (e) {
        let uniqid, token, index, status

        uniqid = e.detail.uniqid;
        token = e.detail.token;
        index = e.detail.index;
        status = e.detail.status;

        this.setData({
            chage_status_obj: {
                show: true,
                uniqid,
                token,
                index,
                status
            }
        })

    },

    change_status: function () {
        var that = this;
        wx.showLoading({
            title: '提交中',
        })
        miucms.request(app.globalData.config.post.status, {
            token: that.data.chage_status_obj.token,
            uniqid: that.data.chage_status_obj.uniqid,
            status: that.data.chage_status_obj.status == 1 ? 2 : 1
        }).then(data => {
            if (data.code == 200) {
                // 成功
                that.data.chage_status_obj.show = false;
                let status = that.data.chage_status_obj.status
                let stat = this.data.stat

                if (status == 1) stat['listing']--
                else if (status == 0) stat['draft']--
                else stat['offshelf']--

                let newStatus = data.data.status
                if (newStatus == 1) stat['listing']++
                else if (newStatus == 0) stat['draft']++
                else stat['offshelf']++

                this.data.publish.data[that.data.chage_status_obj.index].status = newStatus
                this.setData({
                    stat,
                    publish: this.data.publish,
                    chage_status_obj: this.data.chage_status_obj
                })

                wx.showToast({
                    title: data.message,
                })
            } else {
                wx.hideLoading()
                if (data.data && data.data.message) {
                    // 触发规则是 不需要wx.showModal 但是 接口有data.message ，所以排除掉
                } else {
                    wx.showModal({
                        title: '提示',
                        content: data.message
                    })
                }

                this.setData({
                    failPopState: true,
                })

                // if (data.data && data.data.rule) {
                //     this.setData({
                //         triggerRules: data.data.rule,
                //         appealtoken: data.data.appealtoken
                //     })
                // }
                this.close_alert()
            }
        }).catch(res => {})
    },
    // 已租出提示
    have_rent_info: function () {
        wx.showModal({
            title: '提示',
            content: '该房源信息已出租或已失效',
        })
    },
    // 点击顶上去
    bindtopUp(e) {
        let token, index, isding, item
        token = e.detail.token
        index = e.detail.index
        isding = e.detail.isding
        item = e.detail.item

        if (isding == 1) {
            this.setData({
                raisePopupMessage: "今天已顶过啦，明天再来吧！",
                raisePopupState: true,
                isdingState: 1
            })
            this.bindtopUpAnimation()
            return
        }

        const upState = this.getTopUpState()
        // upState: false 代表24小时内 没有弹出认证弹窗
        miucms.request(app.globalData.baseURL + "/tenement/post/ding", {
            token
        }).then(res => {
            if (res.code == 200) {
                if (!upState && item.intermediary == 1 && (this.data.user.intermediary == 0 || this.data.validityidentity)) {
                    // 需要触发 弹窗
                    this.setData({
                        authenticatePopupStatus: true,
                        authenticatePopupState: item.intermediary,
                    })
                    this.setTopUpState()
                } else if (!upState && item.intermediary == 3 && item.verified == 0) {
                    this.setData({
                        authenticatePopupStatus: true,
                        authenticatePopupState: item.intermediary,
                    })
                    this.setTopUpState()
                } else {
                    // 不需要弹窗 弹出提示
                    this.setData({
                        raisePopupMessage: res.message,
                        raisePopupState: true,
                    })
                    setTimeout(() => {
                        this.setData({
                            raisePopupState: false
                        })
                    }, 1500)
                }

                // 修改 顶一顶 的 列表状态
                this.data.publish.data[index].isding = 1
                this.setData({
                    publish_list: this.data.publish_list,
                    publish: this.data.publish,
                })
                return
            }
            // 已经顶过的那些提示
            this.setData({
                raisePopupMessage: res.message || '',
                raisePopupState: true,
                isdingState: 1
            })
            this.bindtopUpAnimation()
        })
    },

    // 顶上去动画
    bindtopUpAnimation(e) {
        setTimeout(() => {
            this.setData({
                raisePopupState: false,
            })
            setTimeout(() => {
                this.setData({
                    isdingState: 0
                })
            }, 500)
        }, 1500)
    },

    // 设置 topUpState 状态为 true，并设置过期时间为24小时后
    setTopUpState() {
        var now = new Date();
        var expireTime = now.getTime() + 24 * 60 * 60 * 1000; // 10 秒的时间戳
        now.setTime(expireTime);

        wx.setStorageSync('topUpState', {
            value: true,
            expireTime: now.getTime()
        });
    },

    // 获取 topUpState 状态
    getTopUpState() {
        var topUpState = wx.getStorageSync('topUpState');
        if (topUpState) {
            var now = new Date().getTime();
            // 用户在24小时内进行了充值操作，topUpState 为 true
            if (now < topUpState.expireTime) return true;
        }

        // 用户超过24小时未进行充值操作，topUpState 为 false
        return false;
    },


    // 撤销审核
    cancelAudit(e) {
        let that = this
        let {
            token,
            index
        } = e.currentTarget.dataset
        wx.showModal({
            title: '提示',
            content: '确认撤销审核？',
            success(res) {
                if (res.confirm) {
                    miucms.request(app.globalData.baseURL + '/tenement/appeal/revoke', {
                        token
                    }).then(res => {
                        if (res.code == 200) {
                            that.data.publish_list[index].status = 0
                            that.setData({
                                publish_list: that.data.publish_list
                            })
                            wx.showToast({
                                title: res.message,
                            })
                        } else if (res.code == 201) {
                            wx.showModal({
                                title: '提示',
                                content: res.message
                            })
                        }
                    })
                }
            }
        })
    },
    unreadMessagesalter(e) {
        if (this.data.isAuthorization == 1) {
            wx.showModal({
                title: '提示',
                content: "权限受限,请先授权"
            })
            return
        }
        wx.navigateTo({
            url: '/pages/messageCenter/messageCenter',
            success: () => {
                if (this.data.unreadMessages > 0) {
                    this.setData({
                        unreadMessages: 0
                    })
                }
                app.globalData.unreadMessages = 0
            }
        })
    },

    // 跳转我要申述
    goAppeal() {
        wx.navigateTo({
            url: '/pages/appeal/appeal?appealtoken=' + this.data.appealtoken,
        })
    },

    // 点击关闭
    triggerRulesClose() {
        this.setData({
            triggerRules: 0
        })
    },

    // 上架触发规则2 弹窗点击下架房源
    goUser() {
        this.triggerRulesClose()
    },
    // 上架触发规则3 点击右上角叉叉
    WechatIDClose() {
        this.triggerRulesClose()
    },

    // 上架触发规则3中的图片预览
    methodPreview() {
        wx.previewImage({
            urls: ["https://oss.gter.net/attachment/Zvt57TuJSUvkyhw-xG7Y2l-T_pIqc3nqqsgFptxhXa6RWi26P-BuTQdCF7eV7tkb8MVYZjQ0Mjk~"],
            current: "https://oss.gter.net/attachment/Zvt57TuJSUvkyhw-xG7Y2l-T_pIqc3nqqsgFptxhXa6RWi26P-BuTQdCF7eV7tkb8MVYZjQ0Mjk~"
        })
    },

    // 授权成功后需要处理的事件
    authorizationSuccess() {
        this.setData({
            initState: false
        })
    },

    // 跳转到认证 介绍
    goApprove() {
        let url = this.data.landlordcertification
        wx.navigateTo({
            url: `/pages/webViewwebweb/index?url=${url}`,
        })
    },

    // 跳转修改头像和昵称页面
    goSetAvatarNickname() {
        wx.navigateTo({
            url: '/pagesLoginRequired/pages/setAvatarNickname/setAvatarNickname',
        })
    },

    // 判断是否 需要 跳转另一个的编辑
    judgeEditSkip(e) {
        let url = e.currentTarget.dataset.url
        let miniProgram = app.globalData['miniProgram']

        if (miniProgram == 'gx') {
            wx.navigateToMiniProgram({
                appId: "wx9c68fbf7886ea9c4",
                path: url
            })
        } else {
            wx.navigateTo({
                url
            })
        }
    },

    cutTab(e) {
        let type = e.currentTarget.dataset.type
        let tab = this.data.tab
        if (tab == type) return
        if (type == 'fav' && this.data.fav['data'].length == 0) this.getFavData()
        else if (type == 'publish' && this.data.publish['data'].length == 0) this.getPublishData()
        this.setData({
            tab: type
        })
    },

    // 获取用户数据
    getUserInit() {
        miucms.request(`${app.globalData.baseURL}/tenement/v2/api/user`).then(res => {
            if (res.code == 401) {
                this.setData({
                    isAuthorization: 1,
                    loding: false,
                })
                return false
            }

            if (res.code != 200) return
            let data = res.data
            let tab = this.data.tab

            if (!this.isMessageState) {
                let count = data['count']
                if (count['publish'] > 0) tab = "publish"
                if (tab == 'fav') this.getFavData()
                else if (tab == 'publish') this.getPublishData()
            } else this.isMessageState = false


            app.globalData.user = data.user

            this.setData({
                landlordcertification: data.landlordcertification,
                user: data.user,
                newmessagenum: data.newmessagenum,
                validityidentity: data.validityidentity || '',
                initState: true,
                loding: false,
                tab
            })

            app.globalData.unreadMessages = data.newmessagenum
        })
    },

    // 获取 收藏数据 V4的
    getFavData() {
        let fav = this.data.fav
        if (fav['page'] == 0) return
        wx.showLoading({
            title: '加载中...',
        })
        // miucms.request(`${app.globalData.baseURL}/tenement/v2/api/user/favList`, {
        miucms.request(`${app.globalData.baseURL}/tenement/v2/api/user/collectionList`, {
            page: fav['page'],
            limit: 20
        }).then(res => {
            if (res.code != 200) return
            let data = res.data
            this.handleDetailData(data.data)
            fav['page'] = data['page'] * data['limit'] >= data['count'] ? 0 : data['page'] + 1
            fav['count'] = data['count']
            this.data.fav = fav
            this.setData({
                fav
            })
        }).finally(() => {
            wx.hideLoading()
        })
    },

    // 获取 发布数据 V4的
    getPublishData() {
        let publish = this.data.publish
        if (publish['page'] == 0 || publish.loading) return
        publish.loading = true
        this.setData({
            publish
        })
        wx.showLoading({
            title: '加载中...',
        })
        miucms.request(`${app.globalData.baseURL}/tenement/v2/api/user/publishList`, {
            page: publish['page'],
            limit: 20
        }).then(res => {
            if (res.code != 200) return
            let data = res.data


            this.handleDetailData(data.data)

            let stat = data.stat
            publish['page'] = data['page'] * data['limit'] >= data['count'] ? 0 : data['page'] + 1
            publish['count'] = data['count']
            this.data.publish = publish
            this.setData({
                publish,
                stat,
            })
        }).finally(() => {
            wx.hideLoading()
            this.setData({
                ['publish.loading']: false
            })
        })
    },

    // 获取语言包 保存全局
    getDtailsLangs() {
        miucms.request(`${app.globalData.baseURL}/tenement/v2/api/details/langs`).then(res => {
            if (res.code != 200) return
            let data = res.data
            this.setData({
                langs: data
            })
            app.globalData['langs'] = data
        })
    },

    // 专门梳理v4出现的 语音包 及 不同房源值的处理
    handleDetailData(data) {
        let langs = this.data.langs || {}
        if (Object.keys(langs).length == 0) {
            setTimeout(() => {
                this.handleDetailData()
            }, 300)
        } else {
            if (!data) return
            data.forEach(ele => {
                // 这个是将 详情键 替换语言包里的值
                let list = ['type', 'rentalduration', 'intermediary', "property", "elevator", "sunshinearea", "gender", "publishergender"]
                if (Array.isArray(ele['floor'])) list.push('floor') //  判断 楼层是否需要 替换值, 因为在求房源里是多个值
                let differentNames = { // 需要替换的 键名
                    "intermediary": "intermediary_text"
                }
                if (Array.isArray(ele.rent)) ele.rent = ele.rent.join(' ~ ')

                list.forEach(element => {
                    if (ele[element] == -1) {} else if (ele[element] == 0) ele[differentNames[element] ? differentNames[element] : element] = '不限' //  当 值为 [0] 时为不限
                    else ele[differentNames[element] ? differentNames[element] : element] = langs[element == 'publishergender' ? 'gender' : element][ele[element]]
                    // else ele[differentNames[element] ? differentNames[element] : element] = langs[element][ele[element]]
                })
                let tabArr = ["gptype", "type", "elevator", "sunshinearea", "gender"]
                let tabList = []
                tabArr.forEach(el => {
                    if (ele[el] && ele[el] != -1 && ele[el] != "不限") tabList.push(ele[el])
                })
                ele['tabList'] = tabList
                let location = langs.location // 遍历替换区域的值  所有房源
                let pendingData = ele['location']
                if (Array.isArray(pendingData)) {
                    let locationList = []
                    for (const key in location) {
                        // if (pendingData.indexOf(key) != -1 && Math.trunc(key) != key) locationList.push(`${location[Math.trunc(key)]} > ${location[key]}`)
                        if (pendingData.indexOf(key) != -1) locationList.push(`${location[Math.trunc(key)]} > ${ Math.trunc(key) != key ? location[key] : '不限' }`)
                    }
                    ele['locationList'] = locationList
                } else if (location[pendingData]) ele['location'] = `${location[Math.trunc(pendingData)]}  >  ${location[pendingData]}`
                else ele['location'] = ""
                if (ele['timestamp']) ele['timestamp'] = this.formatDate(ele['timestamp'])
            })

            let tab = this.data.tab
            let targetData = this.data[tab]["data"] || []
            targetData = [...targetData, ...data]
            this.data[tab]["data"] = targetData
            this.setData({
                [tab]: this.data[tab]
            })
        }

    },

    // V4我的-发布 操作处理的中转
    userOperation(e) {
        let type = e.detail.type
        if (type == "undercarriage") this.change_item_status(e)
        if (type == "del") this.del_item(e)
        if (type == "up") this.bindtopUp(e)
    },

    handleRightBtn(e) {
        let identity = this.data.user.identity
        if (identity == 0) {
            this.judgeIssue()
            return
        }

        let url = ""
        if (identity == 1) url = "https://app.gter.net/special/middlemanAuth"
        else url = "https://app.gter.net/special/propertyAuth"
        wx.navigateTo({
            url: `/pages/webViewwebweb/index?url=${url}`,
        })
    },

    // 发布房源 的 判断
    judgeIssue() {
        if (this.data.identityList.length != 0) {
            this.setData({
                choiceTypeState: true
            })
            return
        }
        miucms.request(`${app.globalData.baseURL}/tenement/v2/api/publish/checkidentity`).then(res => {
            if (res.code == 401) {
                this.setData({
                    isAuthorization: 1
                })
                return
            }
            if (res.code != 200) return
            let data = res.data
            let identityList = data.data
            let isintermediary = data.isintermediary
            if (data['ispopup'] == 0) { // 确认身份 直接跳转

                let user = app.globalData['user']
                let miniProgram = app.globalData.miniProgram
                if (user['uid']) {
                    let url = `/pages/edit/edit?intermediary=${isintermediary}`
                    if (!user['nickname'] || !user['avatar']) {
                        wx.navigateTo({
                            url: '/pagesLoginRequired/pages/setAvatarNickname/setAvatarNickname',
                        })
                        return
                    }
                    if (miniProgram == 'xg') {
                        wx.navigateTo({
                            url,
                        })
                    } else {
                        wx.navigateToMiniProgram({
                            appId: "wx9c68fbf7886ea9c4",
                            path: url
                        })
                    }
                } else {
                    this.setData({
                        isAuthorization: 1
                    })
                }
                return
            }
            this.setData({
                identityList,
                housingnum: data.housingnum,
                isintermediary,
                ispopup: data.ispopup,
                choiceTypeState: true,
            })
        })
    },

    setValue(e) {
        let key,
            value
        if (e.currentTarget.dataset['key']) {
            key = e.currentTarget.dataset['key']
            value = e.currentTarget.dataset['value']
        } else {
            key = e.detail.key
            value = e.detail.value
        }
        this.setData({
            [key]: value
        })
    },

    publicSkip(e) {
        let url = e.currentTarget.dataset.url
        wx.navigateTo({
            url,
        })
    },

    // 展示有效期
    showValidityidentity() {
        this.setData({
            validityidentityState: true
        })

        setTimeout(() => {
            this.setData({
                validityidentityState: false
            })
        }, 2000);
    },

    copy(e) {
        let value = e.currentTarget.dataset.value
        miucms.copy(this.data.wechat.wechat)
    },

    // 输出 时间格式 2023年07月04日
    formatDate(timestamp) {
        // 创建一个新的Date对象，将时间戳作为参数传入
        var date = new Date(timestamp * 1000);
        // 使用Date对象的get方法获取年、月、日
        var year = date.getFullYear();

        var month = date.getMonth() + 1;
        var day = date.getDate();

        // 将月份和日期转为两位数的格式，如果不足两位，前面补0
        if (month < 10) month = '0' + month;
        if (day < 10) day = '0' + day;

        // 返回格式化后的日期字符串
        return year + '年' + month + '月' + day + '日';

    },

    // 是否跳转消息提醒状态
    isMessageState: false, // 判断 是否是从 消息提醒状态返回的使用
    // 跳转消息提醒
    goMessageReminding() {
        wx.navigateTo({
            url: '/pages/messageCenter/messageCenter',
            success: () => {
                this.isMessageState = true
            }
        })
    },

    //查看详情
    publicJumps(e) {
        let url = e.currentTarget.dataset.url
        wx.navigateTo({
            url,
        })

    },

    bindCollect(e) {
        const index = e.currentTarget.dataset.index || 0
        let target = this.data.fav.data[index]

        const baseURL = app.globalData.baseURL

        miucms.request(baseURL + '/tenement/v2/api/user/apartmentCollection', {
            token: target.token
        }).then(res => {
            if (res.code != 200) return
            let data = res.data
            target['collectnum'] = data.count
            this.data.fav.data.splice(index, 1)
            this.data.fav.count = this.data.fav.count - 1
            this.setData({
                fav: this.data.fav
            })
            wx.showToast({
                icon: "none",
                title: res.message,
            })
        })
    },

    // 切换客服状态
    CutQRCodePopState() {
        this.setData({
            QRCodePopState: !this.data.QRCodePopState
        })
    },

    // 点击顶一顶后的暂不认证
    goShowPage() {
        this.setData({
            authenticatePopupStatus: false,
            authenticatePopupState: null,
        })
    },

})