// template/QRCodePop/QRCodePop.js
const app = getApp()
Component({

    /**
     * 组件的属性列表
     */
    properties: {
        typee: {
            type: String,
            observer(res) {
                const wechat = app.globalData.wechat || {}
                let name = ""
                let titleUrl = ""
                let QRCodeUrl = ""
                let nameUrl = ""
                if (res == "irent") {
                    name = wechat.nickname
                    titleUrl = "https://app.gter.net/image/miniApp/HKRenting/welcome-icon.png"
                    nameUrl = "https://app.gter.net/image/miniApp/HKRenting/wechat-name-icon.svg"
                    QRCodeUrl = wechat.wechatqrcode
                } else {
                    name = wechat.MrFang.name
                    titleUrl = "https://app.gter.net/image/miniApp/HKRenting/service-title.png"
                    nameUrl = "https://app.gter.net/image/miniApp/HKRenting/service-name-icon.png"
                    QRCodeUrl = wechat.MrFang.qrcode
                }

                this.setData({
                    name,
                    titleUrl,
                    QRCodeUrl,
                    nameUrl,
                })
            }
        }
    },

    /**
     * 组件的初始数据
     */
    data: {
        name: "",
        nameUrl: "",
        titleUrl: "",
        QRCodeUrl: "",
    },

    /**
     * 组件的方法列表
     */
    methods: {
        closePop() {
            this.triggerEvent("closePop")
        }
    }
})