// pages/video_show/video_show.js
var app = getApp()
var miucms = require('../../utils/miucms.js');

Page({

    /**
     * 页面的初始数据
     */
    // {
    //     url: "",
    //     type: "image"
    // },{
    //     url: "",
    //     poster:"",
    //     type: "video"
    // }
    data: {
        screen_data: {},
        list: [],
        swiperCurrent: 0,
        videoContexts: [],
        videoHeight: 500, // 
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        this.get_config()
        const list = wx.getStorageSync('sourcesList') || []
        // const list = [{
        //     url: "https://oss.x-php.com/Zvt57TuJSUvkyhw-xG7Y2l-S-58odnnqqsgFptxhcq_cQnrlJ_EjCwIUBq_D-81qNDQyOQ~~",
        //     type: "video"
        // },{
        //     url: "https://oss.x-php.com/Zvt57TuJSUvkyhw-xG7Y2l-d95kucn7qqsgFptxhXa6SWi2uePJ5Bg8RFLPIvsEG-4BUDm7F7lfn5E55tXAL34gR30K7Ur1wa7ia1zx17l80NDI5",
        //     type: "image"
        // }]
        let videoContexts = []

        list.forEach((element, index) => {
            if (element.type == "video") videoContexts.push(wx.createVideoContext('video' + index, this))
        })

        this.setData({
            videoContexts,
            swiperCurrent: options.current || 0,
            list,
        });

        wx.removeStorageSync('sourcesList');
    },
    timer: null,

    get_config() {
        if (app.globalData.config.lists) {
            let screen_data = app.globalData.screen_data || {}
            const videoHeight = screen_data.windowHeight - screen_data.bottomLift - screen_data.totalTopHeight
            this.setData({
                screen_data,
                videoHeight,
            })
        } else {
            setTimeout(() => {
                this.get_config()
            }, 200)
        }
    },

    // 新 轮播图 自动滑动事件，修改下标
    bindchangeSwiper(e) {
        let current = e.detail.current
        this.setData({
            swiperCurrent: current
        })

        this.data.videoContexts.forEach((videoContext, i) => {
            if (current != i && videoContext.pause) videoContext.pause();
        });
        this.data.videoContexts[current] && this.data.videoContexts[current].play();
    },

    back() {
        wx.navigateBack({
            fail: err => {
                if (err.errMsg == "navigateBack:fail cannot navigate back at first page.") miucms.goPage("/pages/index/index")
            }
        })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    onVideoPlay(e) {
        const index = e.currentTarget.dataset.index || 0
        // 遍历所有视频上下文，暂停其他视频
        // this.data.videoContexts.forEach((videoContext, i) => {
        //     if (index != i) videoContext.pause();
        // });
    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {

    },
})